var popmsg = {
    't':null,
    'msg':function(msg, out_time,img_url){
        out_time = out_time ? out_time : 1000;
        img_url = img_url ? img_url : 'url(../image/code_unsend_2x.png)';
        $api.css($api.dom('.tips-img'), 'background-image:'+img_url);
        var msgtext = document.getElementById('msgtext');
        $api.text(msgtext,msg);
        $api.css($api.dom('#tips-name'), 'display:block');
        window.clearTimeout(popmsg.t);
        popmsg.t = setTimeout("popmsg.close();", out_time);
    },
    'close':function () {
        window.clearTimeout(popmsg.t);
        $api.css($api.dom('#tips-name'), 'display:none');
    }
};
function fnReady() {
    fnReadyKeyback();
    fnReadyOpenWin();
    fnReadyHeader();
};

function getHeaderHeight() {
    var header = $api.byId('header');
    $api.fixIos7Bar(header);
    headerHeight = $api.offset(header).h;
    return headerHeight;
}

function fnReadyKeyback() {
    var keybacks = $api.domAll('.event-back');
    for (var i = 0; i < keybacks.length; i++) {
        $api.attr(keybacks[i], 'tapmode', 'highlight');
        keybacks[i].onclick = function() {
            api.closeWin();
        };
    }
    api.parseTapmode();
};

function fnReadyOpenWin() {
    var buttons = $api.domAll('.open-win');
    for (var i = 0; i < buttons.length; i++) {
        $api.attr(buttons[i], 'tapmode', 'highlight');
        buttons[i].onclick = function() {
            var target = $api.closest(event.target, '.open-win');
            var winName = $api.attr(target, 'win'),
                isNeedLogin = $api.attr(target, 'register_mobile'),
                param = $api.attr(target, 'param');

            if (isNeedLogin && !$api.getStorage('loginInfo')) {
                winName = 'register_mobile';
            }

            if (param) {
                param = JSON.parse(param);
            }

            api.openWin({
                name: winName,
                url: './' + winName + '.html',
                pageParam: param
            });
        };
    }
    api.parseTapmode();
};

var header, headerHeight = 0;

function fnReadyHeader() {
    header = $api.byId('header');
    if (header) {
        $api.fixIos7Bar(header);
        headerHeight = $api.offset(header).h;
    }
};

function fnReadyFrame() {
    var frameName = api.winName + '_frame';
    api.openFrame({
        name: frameName,
        url: './' + frameName + '.html',
        bounces: true,
        rect: {
            x: 0,
            y: headerHeight,
            w: 'auto',
            h: 'auto'
        },
        vScrollBarEnabled: false
    });
};

function makeImage(el, album,callback){
  api.showProgress({
      title: '正在分享',
      modal: true
  });
  album = album ? album : false;

  html2canvas(el).then(
    // canvas => {
    function(canvas){

      var c_width = canvas.width;
      var c_height = canvas.height;
      var ctx = canvas.getContext("2d");
      var maxwdth = 640;
      //重新设置分享图片大小api.systemType != "ios" &&
      if (api.systemType != "ios" && c_width > maxwdth) {
        var b = maxwdth / c_width;
        var newH = c_height * b;
        var img = new Image();
            img.src = canvas.toDataURL("image/png");
            ctx.clearRect(0,0,canvas.width,canvas.height);
            canvas.width = maxwdth;
            canvas.height = newH;
            ctx.scale(b,b);//x和y方向的缩放比例
            img.onload = function(){//需要加载完图片再渲染画纸
                ctx.drawImage(img, 0, 0);
                var dataUrl = canvas.toDataURL("image/png");
                var pos = dataUrl.indexOf(',');
                if (pos > 0) {
                    _saveImage(dataUrl, pos, album, callback);
                }
            }
      }else {
        var dataUrl = canvas.toDataURL("image/png");
        var pos = dataUrl.indexOf(',');
        if (pos > 0) {
            _saveImage(dataUrl,pos, album, callback);
        }
      }
    });
}
function _saveImage(dataUrl,pos, album, callback){
    // var trans = api.require('trans');
    // var data = dataUrl.substring(pos + 1);
    // var imgname = "bzpp_" + Date.now() + ".png";
    // trans.saveImage({
    //         base64Str : data,
    //         imgPath : 'fs://image/',
    //         imgName : imgname,
    //         album : album
    //   }, function(ret, err) {
    //     api.hideProgress();
    //       if (ret.status) {
    //         var url = "fs://image/"+imgname;
    //         ret.url = url;
    //         callback(ret, err);
    //       } else {
    //           callback(ret, err);
    //       }
    // });
}
function shareImage(channel, contentUrl, thumb, callback){
  var download_url = api.systemType == "ios" ? getAppConfig("iosUrl") : getAppConfig("androidUrl");
  if (channel == "wx" || channel == "wx-timeline" ) {
    var wx = api.require('wx');
    var scene = "session";
    if(channel == "wx-timeline"){
        scene = "timeline";
    }

    var d = {
        "apiKey": '',
        "scene": scene,
        "thumb": thumb,
        "contentUrl": contentUrl
    }
      wx.shareImage(d, callback);
  }else if (channel == "qq") {
    // var qq = api.require('QQPlus');
    // qq.shareImage({
    //     type:"QFriend",
    //     title: '起名猫-宝宝起名',
    //     description: '起名猫-专业起好名!'+ download_url,
    //     imgPath: contentUrl
    // },callback);
  }else if (channel == "sina") {
    // var weibo = api.require('weibo');
    // weibo.shareImage({
    //     text: '起名猫-专业起好名!'+ download_url,
    //     imageUrl: contentUrl
    // }, callback);
  }
}
function shareSelf(channel, text, callback){

  var download_url = api.systemType == "ios" ? getAppConfig("iosUrl") : getAppConfig("androidUrl");
  if (channel == "wx" || channel == "wx-timeline" || channel == "favorite" ) {
    var wx = api.require('wx');
    var scene = "session";
    if(channel == "wx-timeline"){
        scene = "timeline";
    }else if (channel == "favorite") {
        scene = "favorite";
    }
    wx.shareWebpage({
        apiKey: '',
        scene: scene,
        title: api.appName,
        description: text,
        thumb: 'widget://icon/icon108x108.png',
        contentUrl: download_url
    }, callback);
  }else if (channel == "qq") {
    // var qq = api.require('QQPlus');
    //   qq.shareText({
    //       text: text+download_url
    //   });
    //
    //   callback({"status":true},false)

  }else if (channel == "sina") {
    // var weibo = api.require('weibo');
    // weibo.shareText({
    //     text: text+download_url,
    // },callback);
  }
}
function shareWebsite(channel, text, callback){

}
//统一公历显示字符串
function getUserBirthStr(birthday){
  var b = birthday.split(" ");
  var b_date = b[0], b_time = b[1];
  var b_date_arr = b_date.split("-");
  var b_str = b_date_arr[0] + "年" + b_date_arr[1] + "月" + b_date_arr[2] + "日";
  if(b_time){
    var time_arr = b_time.split(":");
    if(time_arr && parseInt(time_arr[0]) >= 0){
        b_str += time_arr[0] + "点";
    }
  }
  return b_str;
}
var getServerConfig = true;
function getAppConfig(keys){
    var a_c_key = "app_config_key";
    var cofig = $api.getStorage(a_c_key);
    if(getServerConfig){
      server.getAppConfig(function(ret, err){
          if (ret != false) {
            getServerConfig = false;
              $api.setStorage(a_c_key, ret);
          }
      });
    }
    if(!cofig || !cofig[keys]){
        cofig = {
          'iosUrl' : "http://www.smxs.com",
          'androidUrl' : 'http://www.smxs.com',
          'shareImage' : 1,
          'shareSelf' : 1,
          'tel' : "15305928960"
        };
    }
    return cofig[keys];
};
function messageTip(msg, isok, out_time, model){
  model = model ? model : 2;
  api.openFrame({
      name: 'msg-tip',
      url: 'widget://html/tip.html',
      rect: {
          x: 0,
          y: 0,
          w: api.winWidth,
          h: api.winHeight
      },
      pageParam: {
          msg: msg,
          isok: isok,
          out_time : out_time,
          model : model
      },
      bounces: false,
      reload:true,
      bgColor: 'rgba(0,0,0,0)',
      vScrollBarEnabled: true,
      hScrollBarEnabled: true
  });
}

function getUid(){
  var key = 'user';
  var user = {};
  var user=$api.getStorage(key,user);
  var uid_tmp = 0;
  if(typeof(user) != "undefined"){
     uid_tmp = user.id;
  }
  return uid_tmp;
}

function goToLogin(t){
  t = t ? t : 800;
  setTimeout(function(){
    api.openWin({
        name: 'login_cellphone',
        url: './login_cellphone.html',
        reload:true,
        pageParam: {
            name: 'test'
        }
    });
  }, t);
}

function fitIpad(){
  if (isIpad()) {
      var height = api.winHeight;
      var height_tm = parseInt(height/13);
      $api.css($api.dom("html"), "font-size:" + height_tm + "px;");
      return height_tm;
  }
  return 0;
}
function isIpad(){
  var system = api.systemType;
  if(system == "ios"){
    var mod = api.deviceModel;
    if (mod.indexOf("iPad") != -1) {
      return true;
    }
  }
  return false;
}
//发起支付
function payIos(order){
  var system = api.systemType;
  if(system != "ios"){
    return false;
  }
  api.writeFile({
      path: 'fs://orderlog.txt',
      data: JSON.stringify(order)
  }, function(ret, err){
    productId = order.product_id;
    var iap = api.require('iap');
    var deviceId = api.deviceId;
    //添加转圈等等提醒
    showProgress('请稍等','正在创建订单，并进行支付', true);
    iap.purchase({
      productId: productId
    }, function(ret, err) {
    });
  });
}
function checkLogin(thisName,openName,lastName) {
  var checkisLogin = $api.getStorage('checkisLogin');
  if(checkisLogin){
    api.closeWin({
        name: thisName
    });
    if(lastName!=''||lastName!="undefined"){
      api.closeWin({
          name: lastName
      });
    }
  }else {
    api.openWin({
        name: openName,
        url: './'+openName+'.html',
        bounces: false,
        slidBackEnabled:false
    });
  }
}
//检测支付回调
function payCallBack() {
    api.readFile({
        path: 'fs://iospaylog.txt'
    }, function(ret, err) {
        if (ret && ret.status == true && ret.data != "") {
            api.readFile({
                path: 'fs://orderlog.txt'
            }, function(wret, err) {
              hideProgress();
                if (wret && wret.status == true && wret.data != '') {
                    hideProgress();
                    showProgress('请稍等','正在同步订单，请稍等...', true);
                    var order = JSON.parse(wret.data);
                    var result_data = JSON.parse(ret.data);
                    userServer.iosOrderBack(order.orderid, order.product, result_data, function(result, msg) {
                        if (result) {
                            api.writeFile({
                                path: 'fs://iospaylog.txt',
                                data: ""
                            }, function(ret, err) {});
                            api.writeFile({
                                path: 'fs://orderlog.txt',
                                data: ""
                            }, function(ret, err) {});
                            api.sendEvent({
                                name: 'detailPaySuccess',
                                extra: "success"
                            });
                            hideProgress();

                        } else if (typeof(msg) == "undefined") {
                            api.confirm({
                                title: '提示',
                                msg: '网络错误请稍后再试',
                                buttons: ['确定']
                            }, function(ret, err) {

                            });
                        } else {
                            api.confirm({
                                title: '提示',
                                msg: msg,
                                buttons: ['确定']
                            }, function(ret, err) {

                            });
                        }
                    });
                };
            });
        }
    });
}
//监听ios支付回调
function listenIosPay(){
  if(api.systemType == 'ios'){
      var iap = api.require('iap');
      iap.setTransactionListener(function(ret, err) {
        console.log("\r\niap:\r\n"+JSON.stringify(ret)+"\r\niap\r\n");
          if (ret) {
              //后端交易字段,0已加入交易队列
              if (ret.state == 0){
                showProgress('请稍等','正在发起支付，请稍等...', true);
              }
              //1、交易完成 3、恢复购买
              if (ret.state == 1 || ret.state == 3) {
                  hideProgress();
                  //记载本次IOS支付数据，验证订单后会清除记录
                  api.writeFile({
                      path: 'fs://iospaylog.txt',
                      data: JSON.stringify(ret)
                  }, function(ret, err){
                      payCallBack();
                  });
              }
              //2交易失败或者取消支付
              if (ret.state == 2){
                   api.alert({msg:"支付失败，请重试！"});
                   api.writeFile({
                       path: 'fs://iospaylog.txt',
                       data: ""
                   }, function(ret, err) {});
                   api.writeFile({
                       path: 'fs://orderlog.txt',
                       data: ""
                   }, function(ret, err) {});
                   hideProgress();
              }
              //4交易等待被确认， iOS 8.0及以后有效
              if (ret.state == 4){
                showProgress('请稍等','交易等待被确认，请稍等...', true);
              }

              } else {
              hideProgress();
              api.confirm({
                  title: '提示',
                  msg: err.msg,
                  buttons: ['确定']
              }, function(ret, err) {

              });
              return;
          }
      });
  }
}
function hideProgress(){
    api.hideProgress();
    api.sendEvent({
        name: 'hideProgress',
        extra: {
            show: false,
        }
    });
}
function showProgress(show_title, show_msg, model){
  api.hideProgress();
  api.sendEvent({
      name: 'hideProgress',
      extra: {
          show: true,
          title: show_title,
          msg : show_msg,
          model : model
      }
  });
}
function fitHideProgress(){
    api.addEventListener({
        name: 'hideProgress'
    }, function(ret, err){
        api.hideProgress();
        var back_data = ret.value;
        console.log(JSON.stringify(back_data));
        if(back_data){
            if (back_data.show && back_data.msg) {
              console.log(back_data.title);
              var show_title = back_data.title ? back_data.title : "请稍等";
              var show_msg = back_data.msg ? back_data.msg : "";
              var model = back_data.model ? back_data.model : false;
              api.showProgress({
                  title: show_title,
                  text: show_msg,
                  modal: model
              });
            }
        }
    });

}
