var userServer = {
  //type 0 账号登录 1 验证码登录 2 微信登录
  login : function (phone, password, code, openid, type, callback){
    var postData = {
      "phone": phone,
      "password" : password,
      "code" : code,
      "openid" : openid,
      "type":type
    };
    Request.fnPost("user_login", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    },1);
  },
  login_weixin : function (openid, callback){
      userServer.login("", "", "", openid, type = 2, callback);
  },
  login_code : function (phone, code, callback) {
      userServer.login(phone, "", code, "", type = 1, callback);
  },
  login_pwd : function (phone, password, callback){
      userServer.login(phone, password, "", "",type = 0, callback);
  },
  //注册 phone 手机号；password 密码 code 验证码，openid 微信opid ，nickname 昵称 head_url 头像url
  // birthday 生日 sex 性别 1男2女  channel渠道(ios/Android) fid 推荐码 mail邮箱 province省 city市
  register : function (phone, password, code, openid, nickname, head_url, birthday, sex,
    channel, fid, mail, province, city, callback){
    var postData = {
      "phone": phone,
      "password" : password,
      "code" : code,
      "openid" : openid,
      "nickname":nickname,
      "head_url":head_url,
      "birthday":birthday,
      "sex":sex,
      "channel":channel,
      "fid":fid,
      "mail":mail,
      "province":province,
      "city":city
    };
    Request.fnPost("user_register", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  //type 0 注册验证码 1 修改信息 2 修改密码 3 登录
  // phone 手机号 wxopenid 微信opid
  sendcode : function (phone, type, wxopenid, callback){

    var postData = {
      'phone': phone,
      'type' : type,
      'wxopenid' : wxopenid
    };
    Request.fnPost("user_sendcode", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  //修改密码 id 用户id ；old_pwd 现有登录密码； new_pwd 新密码
  change_pwd : function (id, old_pwd, new_pwd, callback){
    var postData = {
      'id': id,
      'old' : old_pwd,
      'new' : new_pwd
    };
    Request.fnPost("user_change_pwd", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  //忘记密码 phone 用户手机号 ；newpwd 新密码； code 验证码
  change_pwd_code : function (phone, newpwd, code, callback){
    var postData = {
      'phone': phone,
      'newpwd' : newpwd,
      'code' : code
    };
    Request.fnPost("user_change_pwd_code", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  //修改手机号 id 用户id phone 手机号 code 验证码，修改之前需要发送 类型为2 的验证码
  change_phone : function(id, phone, code, callback){
    var postData = {
      'id': id,
      'phone' : phone,
      'code' : code
    };
    Request.fnPost("user_change_phone", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  //用户信息编辑 id 用户id properties 需要更新数据 如[nickname:测试 ，sex：1]
  edit: function(id, properties, callback){
    var postData = {
      'id': id,
      'properties' : properties
    };
    Request.fnPost("user_edit", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  // 收藏列表 uid 用户id ;page 第几页;birthday生日;sex性别 （1男 2女）;xing 姓氏
  favoriteList : function(uid, page,birthday,sex,xing, callback){
    var postData = {
      'uid': uid,
      'page' : page,
      'birthday' :birthday,
      'sex' : sex,
      'xing' : xing
    };
    Request.fnPost("favorite_list", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
            if (ret.message) {
              err = ret.message;
            }
            callback(false, err);
        }
    });
  },
  //收藏  uid 用户id， xid 姓氏id ，mid 名字id，birthday 生辰
  favoriteAdd : function(uid, xid, mid,birthday,callback){
    var postData = {
      'uid': uid,
      'xid' : xid,
      'mid' : mid,
      'birthday' : birthday
    };
    Request.fnPost("favorite_add", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  //取消收藏 uid 用户id ；ids 需要取消的收藏id数组 [1,2,3]
  favoriteCancel : function(uid, ids,callback){
    var postData = {
      'uid': uid,
      'ids' : ids
    };
    Request.fnPost("favorite_cancel", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  //建议与反馈接口:title标题 ; comment内容 ; phone手机号 ; email邮箱
  commentAdd : function(title,comment,phone,email,type,callback){
    var postData = {
      'title': title,
      'comment': comment,
      'phone':phone,
      'email':email,
      'type':type
    };
    Request.fnPost("comment_add", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  //姓名详情接口:xing姓id ; ming名id; xys喜用神（金木水火土）,可不传 ; uid用户id;birthday 生辰
  xingmingInformation : function(xing,ming,uid,birthday,callback){
    var postData = {
      'xing': xing,
      'ming': ming,
      'uid':uid,
      'birthday':birthday
    };
    Request.fnPost("xingming_information", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  //订单记录接口,已付费生辰：uid 用户id ; page 分页数
  orderList : function(uid,page,callback){
    var postData = {
      'uid': uid,
      'page':page
    };
    Request.fnPost("order_list", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  //订单记录接口,已付费姓名：uid 用户id; page 分页数
  orderXingming : function(uid,page,callback){
    var postData = {
      'uid': uid,
      'page':page
    };
    Request.fnPost("order_xingming", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  //订单查询商品接口,uid 用户id; xid 姓id;birthday 生辰;sex性别;mid 名id
  orderProductList : function(uid,xid,birthday,sex,mid,callback){
    var postData = {
      'uid': uid,
      'xid':xid,
      'birthday':birthday,
      'sex':sex,
      'mid':mid
    };
    Request.fnPost("order_product_list", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  //订单下单接口,uid 用户id; xid 姓id ; birthday 生辰 ; sex 性别 ; mid 名id ; product 选中的产品；channel 支付方式
  orderAdd : function(uid,xid,birthday,sex,mid,product,channel,callback){
    var postData = {
      'uid': uid,
      'xid':xid,
      'birthday':birthday,
      'sex':sex,
      'mid':mid,
      'product':product,
      'channel':channel
    };
    Request.fnPost("order_add", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  //修改生日接口,order_id 修改的订单; birthday 生辰 ; sex 性别 ;
  orderEditOrderBirthday : function(order_id,birthday,sex,callback){
    var postData = {
      'order_id': order_id,
      'birthday':birthday,
      'sex':sex
    };
    Request.fnPost("order_edit_order_birthday", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  iosOrderBack : function (order_id, product, result, callback){
    var postData = {
      'order_id' : order_id,
      'product' : product,
      'result' : result
    };
    Request.fnPost("order_ios_pay_back", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  },
  bazi : function (birthday, callback){
    var bz_key = "user_bazi_" + birthday;
    var bzInfo = $api.getStorage(bz_key, false);
    if (bzInfo) {
        callback(bzInfo, "");
        return true;
    }
    var postData = {
      'birthday' : birthday,
    };
    Request.fnPost("user_bazi", postData, function(ret,err){
        if (ret && ret.status == "ok" && ret.data) {
            $api.setStorage(bz_key, ret.data);
            callback(ret.data, false);
        }else{
          if (ret.message) {
            err = ret.message;
          }
          callback(false, err);
        }
    });
  }
}
